diff a/test/jdk/valhalla/valuetypes/ValueConstantDesc.java b/test/jdk/valhalla/valuetypes/ValueConstantDesc.java
--- /dev/null
+++ b/test/jdk/valhalla/valuetypes/ValueConstantDesc.java
@@ -0,0 +1,74 @@
+/*
+ * Copyright (c) 2021, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+
+/*
+ * @test
+ * @summary Test ConstantDesc for value classes
+ * @enablePreview
+ * @run junit/othervm ValueConstantDesc
+ */
+
+import java.lang.constant.ClassDesc;
+import java.lang.invoke.MethodHandles;
+import java.util.stream.Stream;
+
+import org.junit.jupiter.params.ParameterizedTest;
+import org.junit.jupiter.params.provider.Arguments;
+import org.junit.jupiter.params.provider.MethodSource;
+import static org.junit.jupiter.api.Assertions.*;
+
+public class ValueConstantDesc {
+    static value class V { }
+
+    private static final MethodHandles.Lookup LOOKUP = MethodHandles.lookup();
+
+    static Stream<Arguments> testCases() {
+        return Stream.of(
+                Arguments.of(V.class, "LValueConstantDesc$V;", "ValueConstantDesc$V"),
+                Arguments.of(V[].class, "[LValueConstantDesc$V;", "ValueConstantDesc$V[]"),
+                Arguments.of(V[][].class, "[[LValueConstantDesc$V;", "ValueConstantDesc$V[][]")
+        );
+    }
+
+    @ParameterizedTest
+    @MethodSource("testCases")
+    public void classDesc(Class<?> type, String descriptor, String displayName) throws ReflectiveOperationException {
+        ClassDesc cd = type.describeConstable().orElseThrow();
+        ClassDesc desc = ClassDesc.ofDescriptor(descriptor);
+
+        if (type.isArray()) {
+            assertTrue(cd.isArray());
+            assertFalse(cd.isClassOrInterface());
+        } else {
+            assertFalse(cd.isArray());
+            assertTrue(cd.isClassOrInterface());
+        }
+        assertEquals(cd, desc);
+        assertEquals(cd.displayName(), displayName);
+        assertEquals(cd.descriptorString(), type.descriptorString());
+
+        Class<?> c = cd.resolveConstantDesc(LOOKUP);
+        assertTrue(c == type);
+    }
+}
diff a/test/jdk/valhalla/valuetypes/WeakReferenceTest.java b/test/jdk/valhalla/valuetypes/WeakReferenceTest.java
--- /dev/null
+++ b/test/jdk/valhalla/valuetypes/WeakReferenceTest.java
@@ -0,0 +1,55 @@
+/*
+ * Copyright (c) 2019, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+import java.lang.ref.WeakReference;
+import java.lang.ref.ReferenceQueue;
+
+import jdk.internal.vm.annotation.ImplicitlyConstructible;
+import org.testng.annotations.Test;
+import static org.testng.Assert.*;
+
+/*
+ * @test
+ * @summary Test value classes with Reference types
+ * @enablePreview
+ * @run testng/othervm WeakReferenceTest
+ */
+@Test
+public class WeakReferenceTest {
+    @ImplicitlyConstructible
+    static value class Value {
+    }
+
+    @Test(expectedExceptions = IdentityException.class)
+    static void test1() {
+        Value v = new Value();
+        WeakReference<Value> r = new WeakReference<>(v);
+    }
+
+    @Test(expectedExceptions = IdentityException.class)
+    static void test2() {
+        ReferenceQueue<Object> q = new ReferenceQueue<>();
+        Value v = new Value();
+        WeakReference<Value> r = new WeakReference<>(v, q);
+    }
+}
diff a/test/jdk/valhalla/valuetypes/WeakValuePolicyTest.java b/test/jdk/valhalla/valuetypes/WeakValuePolicyTest.java
--- /dev/null
+++ b/test/jdk/valhalla/valuetypes/WeakValuePolicyTest.java
@@ -0,0 +1,172 @@
+/*
+ * Copyright (c) 2022, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @run testng/othervm WeakValuePolicyTest
+ * @summary Test WeakHashMap.ValuePolicy modes
+ */
+import org.testng.annotations.DataProvider;
+import org.testng.annotations.Test;
+import org.testng.Assert;
+import static org.testng.Assert.*;
+
+import java.util.ArrayList;
+import java.util.Objects;
+import java.util.WeakHashMap;
+import java.lang.ref.Reference;
+import java.lang.ref.ReferenceQueue;
+import java.lang.ref.SoftReference;
+
+@Test
+public class WeakValuePolicyTest {
+
+    record KeyValue(Object key, String value){};
+
+    @DataProvider(name="Keys")
+    KeyValue[] keys() {
+        return new KeyValue[] {
+                new KeyValue(new IntValue(1), "IntValue(1)"),
+                new KeyValue(new StringValue("xyz"), "StringValue(\"xyz\")"),
+                new KeyValue(Integer.valueOf(2), "Integer.valueOf(2)"),
+        };
+    }
+
+    @DataProvider(name="WeakHashMaps")
+    Object[][] weakValuePolicy() {
+        return new Object[][] {
+                {new WeakHashMap<Object, String>(0, 0.75f, WeakHashMap.ValuePolicy.SOFT)},
+                {new WeakHashMap<Object, String>(0, 0.75f, WeakHashMap.ValuePolicy.STRONG)},
+        };
+    }
+
+    @Test(dataProvider="WeakHashMaps")
+    public void putValueSoftStrong(WeakHashMap map) {
+        WeakHashMap.ValuePolicy policy = map.valuePolicy();
+        for (KeyValue kv : keys()) {
+            System.out.println("k: " + kv.key);
+            Assert.assertFalse(map.containsKey(kv.key), "map.contains on empty map: " + kv.key);
+            Assert.assertNull(map.get(kv.key), "map.get on empty map: " + kv.key);
+            var prev = map.put(kv.key, kv.value);
+            Assert.assertNull(prev, "map.put on empty map did not return null: " + kv.key);
+            Assert.assertEquals(map.get(kv.key), kv.value, "map.get after put: " + kv.key);
+
+            forceGC();
+
+            if (kv.key.getClass().isValue() &&
+                    policy.equals(WeakHashMap.ValuePolicy.SOFT)) {
+                Assert.assertFalse(map.containsKey(kv.key), "map.containsKey after GC: " + kv.key);
+                String value = (String)map.get(kv.key);
+                Assert.assertNull(value, "map.get after GC should return null: " + kv.key);
+            } else {
+                prev = map.remove(kv.key);
+                Assert.assertEquals(prev, kv.value, "map.remove: " + kv.key);
+                Assert.assertNull(map.get(kv.key), "map.get after remove: " + kv.key);
+            }
+            Assert.assertTrue(map.isEmpty(), "m.isEmpty()");
+        }
+    }
+
+    @Test
+    public void putValueDiscard() {
+        final WeakHashMap<Object, String> map = new WeakHashMap<>(0, 0.75f, WeakHashMap.ValuePolicy.DISCARD);
+        final IntValue intValue = new IntValue(1);
+        String old = map.put(intValue, "IntValue(1)");
+        Assert.assertNull(old, "old");
+        old = map.get(intValue);
+        Assert.assertNull(old, "get after put of discarded value");
+    }
+
+    @Test
+    public void putValueThrows() {
+        final WeakHashMap<Object, String> map = new WeakHashMap<>(0, 0.75f, WeakHashMap.ValuePolicy.THROW);
+        Assert.assertThrows(IdentityException.class, () -> map.put(new IntValue(1), "IntValue(1)"));
+    }
+
+    private void forceGC()  {
+        Object marker = new Object();
+        ReferenceQueue<Object> queue = new ReferenceQueue<>();
+        SoftReference expected = new SoftReference(marker, queue);
+        marker = null;
+        Reference<?> actual = waitForReference(queue);
+        assertEquals(actual, expected, "Unexpected Reference queued");
+    }
+
+    /**
+     * Wait for any Reference to be enqueued to a ReferenceQueue.
+     * The garbage collector is invoked to find unreferenced objects.
+     *
+     * @param queue a ReferenceQueue
+     * @return true if the reference was enqueued, false if not enqueued within
+     */
+    private static Reference<?> waitForReference(ReferenceQueue<Object> queue) {
+        Objects.requireNonNull(queue, "queue should not be null");
+        ArrayList<Object> chunks = new ArrayList<>(10000);
+        try {
+            for (int i = 0; i < 10_000; i++) {
+                chunks.add(new byte[100_000]);
+            }
+        } catch (OutOfMemoryError oome) {
+
+        } finally {
+            chunks = null;
+        }
+        for (int retries = 100; retries > 0; retries--) {
+            try {
+                var r = queue.remove(10L);
+                if (r != null) {
+                    return r;
+                }
+            } catch (InterruptedException ie) {
+                // ignore, the loop will try again
+            }
+        }
+        return null;
+    }
+
+    static value class IntValue {
+        int value;
+
+        IntValue(int value) {
+            this.value = value;
+        }
+
+        @java.lang.Override
+        public java.lang.String toString() {
+            return "IntValue{" + "value=" + value + '}';
+        }
+    }
+
+    static value class StringValue {
+        String value;
+
+        StringValue(String value) {
+            this.value = value;
+        }
+
+        @java.lang.Override
+        public java.lang.String toString() {
+            return "StringValue{" + "value='" + value + '\'' + '}';
+        }
+    }
+}
diff a/test/jtreg-ext/requires/VMProps.java b/test/jtreg-ext/requires/VMProps.java
--- a/test/jtreg-ext/requires/VMProps.java
+++ b/test/jtreg-ext/requires/VMProps.java
@@ -387,10 +387,11 @@
         vmOptFinalFlag(map, "ClassUnloading");
         vmOptFinalFlag(map, "ClassUnloadingWithConcurrentMark");
         vmOptFinalFlag(map, "CriticalJNINatives");
         vmOptFinalFlag(map, "EnableJVMCI");
         vmOptFinalFlag(map, "EliminateAllocations");
+        vmOptFinalFlag(map, "TieredCompilation");
         vmOptFinalFlag(map, "UseCompressedOops");
         vmOptFinalFlag(map, "UseVectorizedMismatchIntrinsic");
         vmOptFinalFlag(map, "UseVtableBasedCHA");
         vmOptFinalFlag(map, "ZGenerational");
     }
diff a/test/langtools/jdk/javadoc/doclet/testValueClasses/TestValueClasses.java b/test/langtools/jdk/javadoc/doclet/testValueClasses/TestValueClasses.java
--- /dev/null
+++ b/test/langtools/jdk/javadoc/doclet/testValueClasses/TestValueClasses.java
@@ -0,0 +1,66 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * @test
+ * @bug      8308590
+ * @summary  value classes
+ * @library  /tools/lib ../../lib
+ * @modules jdk.javadoc/jdk.javadoc.internal.tool
+ * @build    toolbox.ToolBox javadoc.tester.*
+ * @run main TestValueClasses
+ */
+
+import java.io.IOException;
+import java.nio.file.Path;
+
+import javadoc.tester.JavadocTester;
+import toolbox.ToolBox;
+
+public class TestValueClasses extends JavadocTester {
+
+    public static void main(String... args) throws Exception {
+        var tester = new TestValueClasses();
+        tester.runTests();
+    }
+
+    private final ToolBox tb = new ToolBox();
+
+    @Test
+    public void testValueClassModifiers(Path base) throws IOException {
+        Path src = base.resolve("src");
+        tb.writeJavaFiles(src,
+                "package p; public value class ValueClass {}");
+
+        javadoc("-d", base.resolve("out").toString(),
+                "--enable-preview", "-source", String.valueOf(Runtime.version().feature()),
+                "-sourcepath", src.toString(),
+                "p");
+        checkExit(Exit.OK);
+
+        checkOutput("p/ValueClass.html", true,
+                """
+                <div class="type-signature"><span class="modifiers">public value final class </span><span class="element-name type-name-label">ValueClass</span>
+                """);
+    }
+}
diff a/test/langtools/jdk/jshell/Test8294583.java b/test/langtools/jdk/jshell/Test8294583.java
--- a/test/langtools/jdk/jshell/Test8294583.java
+++ b/test/langtools/jdk/jshell/Test8294583.java
@@ -25,10 +25,11 @@
  * @test
  * @bug 8294583
  * @summary JShell: NPE in switch with non existing record pattern
  * @build KullaTesting TestingInputStream
  * @run testng Test8294583
+ * @ignore 8316628
  */
 
 import org.testng.annotations.Test;
 import static org.testng.Assert.assertEquals;
 
diff a/test/langtools/jdk/jshell/Test8296012.java b/test/langtools/jdk/jshell/Test8296012.java
--- a/test/langtools/jdk/jshell/Test8296012.java
+++ b/test/langtools/jdk/jshell/Test8296012.java
@@ -25,10 +25,11 @@
  * @test
  * @bug 8296012
  * @summary jshell crashes on mismatched record pattern
  * @build KullaTesting TestingInputStream
  * @run testng Test8296012
+ * @ignore 8316628
  */
 
 import org.testng.annotations.Test;
 import static org.testng.Assert.assertEquals;
 
diff a/test/langtools/jdk/jshell/ToolEnablePreviewTest.java b/test/langtools/jdk/jshell/ToolEnablePreviewTest.java
--- a/test/langtools/jdk/jshell/ToolEnablePreviewTest.java
+++ b/test/langtools/jdk/jshell/ToolEnablePreviewTest.java
@@ -24,10 +24,11 @@
 /*
  * @test
  * @bug 8199193
  * @summary Tests for the --enable-preview option
  * @run testng ToolEnablePreviewTest
+ * @ignore 8316628
  */
 
 import org.testng.annotations.Test;
 
 import static org.testng.Assert.assertTrue;
diff a/test/langtools/lib/combo/tools/javac/combo/CompilationTestCase.java b/test/langtools/lib/combo/tools/javac/combo/CompilationTestCase.java
--- a/test/langtools/lib/combo/tools/javac/combo/CompilationTestCase.java
+++ b/test/langtools/lib/combo/tools/javac/combo/CompilationTestCase.java
@@ -110,10 +110,14 @@
 
     protected void assertOKWithWarning(String warning, String... constructs) {
         assertCompile(expandMarkers(constructs), () -> assertCompileSucceededWithWarning(warning), false);
     }
 
+    protected void assertOKWithWarning(String warning, int numberOfTimes, String... constructs) {
+        assertCompile(expandMarkers(constructs), () -> assertCompileSucceededWithWarning(warning, numberOfTimes), false);
+    }
+
     protected void assertFail(String expectedDiag, String... constructs) {
         assertCompile(expandMarkers(constructs), () -> assertCompileFailed(expectedDiag), false);
     }
 
     protected void assertFail(String expectedDiag, Consumer<Diagnostic<?>> diagConsumer, String... constructs) {
diff a/test/langtools/lib/combo/tools/javac/combo/Diagnostics.java b/test/langtools/lib/combo/tools/javac/combo/Diagnostics.java
--- a/test/langtools/lib/combo/tools/javac/combo/Diagnostics.java
+++ b/test/langtools/lib/combo/tools/javac/combo/Diagnostics.java
@@ -82,10 +82,16 @@
         return diags.stream()
                     .filter(d -> d.getKind() == Diagnostic.Kind.WARNING || d.getKind() == Diagnostic.Kind.MANDATORY_WARNING)
                     .anyMatch(d -> d.getCode().equals(key));
     }
 
+    public boolean containsWarningKey(String key, int numberOfWarnings) {
+        return diags.stream()
+                .filter(d -> d.getKind() == Diagnostic.Kind.WARNING || d.getKind() == Diagnostic.Kind.MANDATORY_WARNING)
+                .filter(d -> d.getCode().equals(key)).count() == numberOfWarnings;
+    }
+
     /** Get the error keys */
     public List<String> errorKeys() {
         return diags.stream()
                     .filter(d -> d.getKind() == Diagnostic.Kind.ERROR)
                     .map(Diagnostic::getCode)
diff a/test/langtools/lib/combo/tools/javac/combo/JavacTemplateTestBase.java b/test/langtools/lib/combo/tools/javac/combo/JavacTemplateTestBase.java
--- a/test/langtools/lib/combo/tools/javac/combo/JavacTemplateTestBase.java
+++ b/test/langtools/lib/combo/tools/javac/combo/JavacTemplateTestBase.java
@@ -152,10 +152,18 @@
         if (!diags.containsWarningKey(warning)) {
             fail(String.format("Expected compilation warning with %s, found %s", warning, diags.keys()));
         }
     }
 
+    protected void assertCompileSucceededWithWarning(String warning, int numberOfWarnings) {
+        if (diags.errorsFound())
+            fail("Expected successful compilation");
+        if (!diags.containsWarningKey(warning, numberOfWarnings)) {
+            fail(String.format("Expected compilation warning with %s, found %s", warning, diags.keys()));
+        }
+    }
+
     /**
      * If the provided boolean is true, assert all previous compiles succeeded,
      * otherwise assert that a compile failed.
      * */
     protected void assertCompileSucceededIff(boolean b) {
diff a/test/langtools/tools/javac/AnonymousClass/AnonymousClassFlags.java b/test/langtools/tools/javac/AnonymousClass/AnonymousClassFlags.java
--- a/test/langtools/tools/javac/AnonymousClass/AnonymousClassFlags.java
+++ b/test/langtools/tools/javac/AnonymousClass/AnonymousClassFlags.java
@@ -47,42 +47,42 @@
     private static Map<String, Integer> anonClasses = new LinkedHashMap<>();
 
     // ******* TEST CASES ********
 
     static Object o1 = new Object() {
-        { anonClasses.put(getClass().getName(), 0); }
+        { anonClasses.put(getClass().getName(), ClassFile.ACC_IDENTITY); }
     };
 
     static void staticMethod() {
         Object o2 = new Object() {
-            { anonClasses.put(getClass().getName(), 0); }
+            { anonClasses.put(getClass().getName(), ClassFile.ACC_IDENTITY); }
         };
     }
 
     static {
         staticMethod();
 
         Object o3 = new Object() {
-            { anonClasses.put(getClass().getName(), 0); }
+            { anonClasses.put(getClass().getName(), ClassFile.ACC_IDENTITY); }
         };
     }
 
     Object o4 = new Object() {
-        { anonClasses.put(getClass().getName(), 0); }
+        { anonClasses.put(getClass().getName(), ClassFile.ACC_IDENTITY); }
     };
 
     void instanceMethod() {
         Object o5 = new Object() {
-            { anonClasses.put(getClass().getName(), 0); }
+            { anonClasses.put(getClass().getName(), ClassFile.ACC_IDENTITY); }
         };
     }
 
     {
         instanceMethod();
 
         Object o6 = new Object() {
-            { anonClasses.put(getClass().getName(), 0); }
+            { anonClasses.put(getClass().getName(), ClassFile.ACC_IDENTITY); }
         };
     }
 
     // ******* TEST IMPLEMENTATION ********
 
@@ -103,12 +103,12 @@
         }
     }
 
     static void assertClassFlags(ClassModel classFile, String name, int expected) {
         int mask = ClassFile.ACC_PUBLIC | ClassFile.ACC_FINAL | ClassFile.ACC_INTERFACE | ClassFile.ACC_ABSTRACT |
-                   ClassFile.ACC_SYNTHETIC | ClassFile.ACC_ANNOTATION | ClassFile.ACC_ENUM;
-        int classExpected = (expected & mask) | ClassFile.ACC_SUPER;
+                   ClassFile.ACC_SYNTHETIC | ClassFile.ACC_ANNOTATION | ClassFile.ACC_ENUM | ClassFile.ACC_IDENTITY;
+        int classExpected = (expected & mask);
         int classActual = classFile.flags().flagsMask();
         if (classActual != classExpected) {
             throw new AssertionError("Incorrect access_flags for class " + name +
                                      ": expected=" + classExpected + ", actual=" + classActual);
         }
diff a/test/langtools/tools/javac/DefiniteAssignment/DA_DUConstructors.java b/test/langtools/tools/javac/DefiniteAssignment/DA_DUConstructors.java
--- /dev/null
+++ b/test/langtools/tools/javac/DefiniteAssignment/DA_DUConstructors.java
@@ -0,0 +1,91 @@
+/*
+ * @test /nodynamiccopyright/
+ * @bug 8324873
+ * @summary [lworld] implementation of value classes construction
+ * @enablePreview
+ * @compile/fail/ref=DA_DUConstructors.out -XDrawDiagnostics DA_DUConstructors.java
+ */
+
+public class DA_DUConstructors {
+    // identity
+    class C1 {
+        final int x;
+        final int y = x + 1;
+        C1() {
+            x = 12;
+            super();
+        }
+    }
+
+    class C2 {
+        final int x;
+        C2() {
+            this(x = 3); // error
+        }
+        C2(int i) {
+            x = 4;
+        }
+    }
+
+    class C3 {
+        C3(int i) {}
+    }
+    class C4 extends C3 {
+        final int x;
+        C4() {
+            super(x = 3); // ok
+        }
+    }
+
+    class C5 {
+        final int x;
+        final int y = x + 1; // x is not DA
+        C5() {
+            x = 12; super();
+        }
+        C5(int i) {
+            /* no prologue */
+            x = i;
+        }
+    }
+
+    // value classes
+    value class V1 {
+        int x;
+        int y = x + 1; // allowed
+        V1() {
+            x = 12;
+            // super();
+        }
+    }
+
+    value class V2 {
+        int x;
+        V2() { this(x = 3); } // error
+        V2(int i) { x = 4; }
+    }
+
+    abstract value class AV1 {
+        AV1(int i) {}
+    }
+
+    value class V3 extends AV1 {
+        int x;
+        V3() {
+            super(x = 3); // ok
+        }
+    }
+
+    value class V4 { // OK
+        int x;
+        int y = x + 1;
+
+        V4() {
+            x = 12;
+        }
+
+        V4(int i) {
+            x = i;
+        }
+    }
+}
diff a/test/langtools/tools/javac/SuperInit/SuperInitFails.java b/test/langtools/tools/javac/SuperInit/SuperInitFails.java
--- a/test/langtools/tools/javac/SuperInit/SuperInitFails.java
+++ b/test/langtools/tools/javac/SuperInit/SuperInitFails.java
@@ -89,11 +89,11 @@
             return;                     // this should FAIL
         super();
     }
 
     public SuperInitFails(short[] x) {
-        this.x = x.length;              // this should FAIL
+        this.x = x.length;              // this should work
         super();
     }
 
     public SuperInitFails(float[] x) {
         System.identityHashCode(this);  // this should FAIL
diff a/test/langtools/tools/javac/SuperInit/SuperInitGood.java b/test/langtools/tools/javac/SuperInit/SuperInitGood.java
--- a/test/langtools/tools/javac/SuperInit/SuperInitGood.java
+++ b/test/langtools/tools/javac/SuperInit/SuperInitGood.java
@@ -23,10 +23,11 @@
 /*
  * @test
  * @bug 8194743
  * @summary Test valid placements of super()/this() in constructors
  * @enablePreview
+ * @ignore fails at execution time because of Optional
  */
 
 import java.util.concurrent.atomic.AtomicReference;
 
 public class SuperInitGood {
diff a/test/langtools/tools/javac/SuperInit/ValueClassSuperInitFails.java b/test/langtools/tools/javac/SuperInit/ValueClassSuperInitFails.java
--- /dev/null
+++ b/test/langtools/tools/javac/SuperInit/ValueClassSuperInitFails.java
@@ -0,0 +1,181 @@
+/*
+ * @test /nodynamiccopyright/
+ * @bug 8324873
+ * @summary Permit additional statements before this/super in constructors
+ * @compile/fail/ref=ValueClassSuperInitFails.out -XDrawDiagnostics ValueClassSuperInitFails.java
+ * @enablePreview
+ */
+
+abstract value class AR<V> implements java.io.Serializable {
+    public AR(V initialValue) {
+    }
+
+    public AR() {
+    }
+}
+
+value class ValueClassSuperInitFails extends AR <Object> implements Iterable<Object> {
+
+    private int x;
+
+/// GOOD EXAMPLES
+
+    public ValueClassSuperInitFails() {           // this should be OK
+        // super()
+    }
+
+    public ValueClassSuperInitFails(Object x) {
+        this.x = x.hashCode();          // this should be OK
+        // super();  the compiler will introduce the super call at this location
+    }
+
+    public ValueClassSuperInitFails(byte x) {
+        super();                        // this should be OK
+    }
+
+    public ValueClassSuperInitFails(char x) {
+        this((int)x);                   // this should be OK
+    }
+
+/// FAIL EXAMPLES
+
+    {
+        this(1);                        // this should FAIL
+    }
+
+    {
+        super();                        // this should FAIL
+    }
+
+    void normalMethod1() {
+        super();                        // this should FAIL
+    }
+
+    void normalMethod2() {
+        this();                         // this should FAIL
+    }
+
+    void normalMethod3() {
+        Runnable r = () -> super();     // this should FAIL
+    }
+
+    void normalMethod4() {
+        Runnable r = () -> this();      // this should FAIL
+    }
+
+    public ValueClassSuperInitFails(short x) {
+        hashCode();                     // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(float x) {
+        this.hashCode();                // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(int x) {
+        super.hashCode();               // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(long x) {
+        ValueClassSuperInitFails.this.hashCode();      // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(double x) {
+        ValueClassSuperInitFails.super.hashCode();     // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(byte[] x) {
+        {
+            super();                    // this should FAIL
+        }
+    }
+
+    public ValueClassSuperInitFails(char[] x) {
+        if (x.length == 0)
+            return;                     // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(short[] x) {
+        this.x = x.length;              // this should be OK
+        //super();
+    }
+
+    public ValueClassSuperInitFails(float[] x) {
+        System.identityHashCode(this);  // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(int[] x) {
+        this(this);                     // this should FAIL
+    }
+
+    public ValueClassSuperInitFails(long[] x) {
+        this(Object.this);              // this should FAIL
+    }
+
+    public ValueClassSuperInitFails(double[] x) {
+        Iterable.super.spliterator();   // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(byte[][] x) {
+        super(new Object() {
+            {
+                super();                // this should FAIL
+            }
+        });
+    }
+
+    public ValueClassSuperInitFails(char[][] x) {
+        new Inner1();                   // this should FAIL
+        //super();
+    }
+
+    class Inner1 {
+    }
+
+    record Record1(int value) {
+        Record1(float x) {              // this should FAIL
+        }
+    }
+
+    record Record2(int value) {
+        Record2(float x) {              // this should FAIL
+            super();
+        }
+    }
+
+    @Override
+    public java.util.Iterator<Object> iterator() {
+        return null;
+    }
+
+    public ValueClassSuperInitFails(short[][] x) {
+        class Foo {
+            Foo() {
+                ValueClassSuperInitFails.this.hashCode();
+            }
+        };
+        new Foo();                      // this should FAIL
+        //super();
+    }
+
+    public ValueClassSuperInitFails(float[][] x) {
+        Runnable r = () -> {
+            super();                    // this should FAIL
+        };
+    }
+
+    public ValueClassSuperInitFails(int[][] z) {
+        super((Runnable)() -> x);       // this should FAIL
+    }
+
+    public ValueClassSuperInitFails(long[][] z) {
+        super(new Inner1());            // this should FAIL
+    }
+}
